﻿#if UNITY_EDITOR
using UnityEngine;
using UnityEditor;

public class AddParentGameObject : EditorWindow
{
	
	[MenuItem("Tools/Add Parent GameObject %g")]
	private static void CreateParent()
	{
		Transform[] selectedGameObjects = Selection.transforms;
		if (selectedGameObjects.Length == 0)
			return;
		
		Vector3 averagePos = Vector3.zero;
		for(int i = 0; i < selectedGameObjects.Length; i++)
		{
			averagePos += selectedGameObjects[i].position;
		}
		
		averagePos = averagePos / selectedGameObjects.Length;
		
		GameObject newParent = new GameObject("Parent");
		Undo.RegisterCreatedObjectUndo(newParent, "Add Parent GameObject");
		newParent.transform.position = averagePos;
		newParent.transform.SetParent(selectedGameObjects[0].parent, true);
		newParent.transform.localScale = Vector3.one;
		
		Undo.RecordObjects(selectedGameObjects, "Add Parent GameObject");
		for (int i = 0; i < selectedGameObjects.Length; i++)
		{
			Undo.SetTransformParent(selectedGameObjects[i], newParent.transform, "Add Parent GameObject");
			selectedGameObjects[i].SetParent(newParent.transform, true);
		}
		
		Selection.activeGameObject = newParent;
	}
	
	[MenuItem("Tools/Add Parent GameObject %g", true)]
	static bool ValidateCreateParent()
	{
		// Return false if no transform is selected.
		return Selection.transforms.Length > 0;
	}
}

#endif