﻿using UnityEngine;
using System.Collections;

public class PaintingTint : MonoBehaviour {
	

	// Use this for initialization
	void Start () {
		Vector3 hsv = new Vector3( Random.Range(0f,360f), 0.5f, 0.95f );
		Color col = HSVtoRGB ( hsv );
		Material mat = GetComponent<Renderer>().materials[1];
		mat.SetInt( "_Channel", Random.Range( 0,2 ) );
		mat.SetColor( "_Color", col );

		hsv = new Vector3( Random.Range(0f,360f), 0.5f, 0.95f );
		col = HSVtoRGB( hsv );
		mat.SetColor( "_Color2", col );
	}
	
	Color HSVtoRGB( Vector3 hsv ) {
		Vector3 rgb;

		float hf = hsv.x/60f;
		int i = Mathf.FloorToInt(hf);
		float f = hf - i;
		float pv = hsv.z * ( 1 - hsv.y );
		float qv = hsv.z * ( 1 - hsv.y*f );
		float tv = hsv.z * ( 1 - hsv.y*(1 - f) );
		switch (i) {
			//red
		case 0:
			rgb.x = hsv.z;
			rgb.y = tv;
			rgb.z = pv;
			break;
		case 5:
			rgb.x = hsv.z;
			rgb.y = pv;
			rgb.z = qv;
			break;
			// green
		case 1:
			rgb.x = qv;
			rgb.y = hsv.z;
			rgb.z = pv;
			break;
		case 2:
			rgb.x = pv;
			rgb.y = hsv.z;
			rgb.z = tv;
			break;
		// blue
		case 3:
			rgb.x = pv;
			rgb.y = qv;
			rgb.z = hsv.z;
			break;
		case 4:
			rgb.x = tv;
			rgb.y = pv;
			rgb.z = hsv.z;
			break;
		default:
			Debug.LogWarning( "undefined colour" );
			rgb = Vector3.one*hsv.z; // pretend black and white
			break;
	}

		return new Color( rgb.x, rgb.y, rgb.z );;
	}
}
