﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine.UI;

public class PlayerController : Mover {

	public GameObject projectile;
	private float refirerate = 3f;
	private float refiretime = 0f;

	private GameObject glowbar;
	private Vector3 glowbarscale;
	private Vector3 glowbarpos;

	private List<GameObject> objectives;
	private Text objectivetext;
	private bool hasobjective = false;

	private Vector3 lastmouse = Vector3.zero;


	protected override void Start() {
		base.Start();
		glowbar = transform.FindChild( "GlowBar" ).gameObject;
		glowbarpos = glowbar.transform.localPosition;
		glowbarscale = glowbar.transform.localScale;
		objectives = GameObject.FindGameObjectsWithTag( "Artefact" ).ToList();
		objectivetext = GameObject.Find( "Canvas" ).transform.FindChild( "Text" ).GetComponent<Text>();
		objectivetext.text = "Artefacts remaining: " + objectives.Count;
	}


	// Update is called once per frame
	void FixedUpdate () {
		if ( !FadeInOut.fading ) {
			if ( Input.GetKey( KeyCode.Escape ) ) {
				FadeInOut.LoadLevel(0);
			} else {


				Vector3 stickdir = Vector3.zero;
				Vector3 viewdir = Vector3.zero;

				stickdir.x = Input.GetAxis( "Horizontal" );
				stickdir.z = Input.GetAxis( "Vertical" );

				viewdir.x = Input.GetAxis( "ViewHorizontal" );
				viewdir.z = Input.GetAxis( "ViewVertical" );
				//Debug.Log( viewdir );

				if ( stickdir == Vector3.zero && viewdir == Vector3.zero ) {
					if ( Input.mousePosition != lastmouse ) {
						// if no controller input and the mouse has moved since the last time we logged it, we're using mouse controls!
						RaycastHit[] mousehits;
						Ray mouseray = Camera.main.ScreenPointToRay( Input.mousePosition );
						Debug.DrawRay( mouseray.origin, mouseray.direction*20f, Color.yellow );
						mousehits = Physics.RaycastAll( mouseray );
						foreach ( RaycastHit h in mousehits ) {
							if ( h.collider.tag == "Ground" ) {
								viewdir = h.point - rbody.position;
								viewdir.y = 0;
								viewdir.Normalize();
								//viewdir *= Input.GetAxis( "Forward" );
								//Debug.Log(stickdir);
							}
						}
						lastmouse = Input.mousePosition;
					}
					Vector3 keydir = Vector3.zero;

					keydir.x = Input.GetAxis( "KeyHorizontal" );
					keydir.z = Input.GetAxis( "KeyVertical" );
					if ( keydir != Vector3.zero ) {
						stickdir = keydir;
						stickdir = Quaternion.Euler( 0f,-45f,0f ) * stickdir;
					}
				} else {
					stickdir = Quaternion.Euler( 0f,-45f,0f ) * stickdir;
					viewdir = Quaternion.Euler( 0f,-45f,0f ) * viewdir;

				}
				Movement( stickdir );
				if ( viewdir != Vector3.zero ) {
					ViewRotation( viewdir );
				}


				if ( ( Input.GetButton( "Fire" ) || Input.GetMouseButton(0) ) && Time.time > refiretime ) {
					refiretime = Time.time + refirerate;


					RaycastHit hit;
					bool guardhit = false;
					int attemptsleft = 5;
					float ang = 0f;
					while ( !guardhit && attemptsleft > 0 ) {
						ang = ((float)attemptsleft - 3f)*5f;
						//Debug.Log( ang );
						//Debug.DrawLine( transform.position, transform.position+Quaternion.Euler( 0f, ang, 0f)*transform.forward*15f, Color.magenta, 0.1f );
						if ( Physics.Raycast( transform.position, Quaternion.Euler( 0f, ang, 0f)*transform.forward, out hit, 15f ) ) {
							if ( hit.collider.tag == "Guard" ) {
								guardhit = true;
							}
						}
						attemptsleft --;
					}
					if ( !guardhit ) {
						ang = 0f;
					}

					GameObject proj = GameObject.Instantiate( projectile );
					proj.GetComponent<Rigidbody>().AddForce( Quaternion.Euler( 0f, ang, 0f)*transform.forward*1000f );
					proj.transform.position = transform.TransformPoint( 0f, 0f, 1f );
				}

				Vector3 newscale = glowbarscale;
				Vector3 newpos = glowbarpos;
				float percent = (1f-Mathf.Clamp01(( refiretime - Time.time )/refirerate));
				newscale.y = newscale.y * percent;

				newpos.y = newpos.y - glowbarscale.y/2f + newscale.y/2f ;

				glowbar.transform.localScale = newscale; 
				glowbar.transform.localPosition = newpos;
			}
		}
	}


	public void PickedUpObjective( GameObject o ) {
		objectives.Remove( o );
		objectivetext.text = "Artefacts remaining: " + objectives.Count;
		if ( objectives.Count == 0 ) {
			hasobjective = true;
		}
	}

	public bool HasObjective {
		get { return hasobjective; }
	}


}


