﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class RayCone : MonoBehaviour {

	private GuardController gc;

	private float spread;
	private float dist;

	private Mesh mesh;
	private Vector3[] verts = new Vector3[30]; // 30 verts = 28 tris = 84 triangle verts
	private int[] tris = new int[84];

	// Use this for initialization
	void Start () {
		gc = transform.root.gameObject.GetComponent<GuardController>();	
		spread = gc.viewangle;
		dist = gc.viewdistance;
		mesh = GetComponent<MeshFilter>().mesh;



	}
	
	// Update is called once per frame
	void Update () {
		mesh.Clear();
		verts[0] = Vector3.zero;
		float ang = -spread;
		float angdelta = 2f*spread/29f;
		for( int i = 1; i < 30; i++ ) {
			RaycastHit hit;
			Vector3 point;
			Vector3 dir = Quaternion.Euler( 0f, ang, 0f)*-Vector3.forward;
			//Debug.DrawLine( transform.position, transform.position+ (transform.rotation*dir*dist), Color.red );
			Ray r = new Ray( transform.position, transform.rotation*dir );
			//Debug.DrawRay( r.origin, r.direction*dist, Color.red );
			if ( Physics.Raycast( r, out hit, dist ) ) {
				point = Quaternion.Inverse(transform.rotation)*(hit.point-transform.position);
			} else {
				point = dir*dist;
			}
			verts[i] = point;
			ang += angdelta;
		}
		for( int j = 0; j < 84; j+=3 ) {
			tris[j] = 0;// always start at the base of the fan;
			tris[j+1] = j/3+1;
			tris[j+2] = j/3+2;
		}
		mesh.vertices = verts;
		mesh.triangles = tris;
	}
}
